/* ripped straight from amcl */


//#include <config.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <gtk/gtk.h>
#include <errno.h>
#include <netdb.h>
#include <string.h>
#include <unistd.h>

/*
 * Added by Michael Stevens
 */
#ifndef INHIBIT_STRING_HEADER
# if defined (HAVE_STRING_H) || defined (STDC_HEADERS) || defined (_LIBC)
#  include <string.h>
#  ifndef bcmp
#   define bcmp(s1, s2, n) memcmp ((s1), (s2), (n))
#  endif
#  ifndef bcopy
#   define bcopy(s, d, n)  memcpy ((d), (s), (n))
#  endif
#  ifndef bzero
#   define bzero(s, n)     memset ((s), 0, (n))
#  endif
# else
#  include <strings.h>
# endif
#endif

#ifdef HAVE_TELNET_H
#include <telnet.h>
#endif
//#ifdef HAVE_ARPA_TELNET_H
#include <arpa/telnet.h>
//#endif

#include "bmud.h"

/*
 * Global Variables
 */
int  sockfd;
int connected;
int echo;
gint input_monitor;

const	char	echo_off_str	[] = { IAC, WILL, TELOPT_ECHO, '\0' };
const	char	echo_on_str	[] = { IAC, WONT, TELOPT_ECHO, '\0' };
const	char 	go_ahead_str	[] = { IAC, GA, '\0' };



void make_connection (char *host, char *port)
{
    char buf[2048];

    if ( !(strcmp (host, "\0")) )
    {
        sprintf (buf, "*** Can't connect - you didn't specify a host\n");
        textfield_add ( buf, MESSAGE_ERR);
        return;
    }

    if ( !(strcmp(port, "\0")) )
    {
        sprintf (buf, "*** No port specified - assuming port 23\n");
        textfield_add ( buf, MESSAGE_NORMAL);
        port = "23\0";
    }

    sprintf (buf, "*** Making connection to %s, port %s\n", host, port);
    textfield_add ( buf, MESSAGE_NORMAL);

    open_connection ( host, port);
}

void disconnect ( void )
{
    close (sockfd);
    gdk_input_remove (input_monitor);
    textfield_add ( "*** Connection closed.\n", MESSAGE_NORMAL);
    connected = FALSE;
}

void open_connection ( const char *host, const char *port)
{
    struct hostent *he;
    struct sockaddr_in their_addr;

    /* strerror(3) */
    if ( ( he = gethostbyname (host) ) == NULL )
    {
        return;
    }

    if ( ( sockfd = socket (AF_INET, SOCK_STREAM, 0)) == -1 )
    {
        textfield_add (strerror(errno), MESSAGE_ERR);
        return;
    }

    their_addr.sin_family = AF_INET;
    their_addr.sin_port   = htons( atoi (port));
    their_addr.sin_addr   = *((struct in_addr *)he->h_addr);
    bzero (&(their_addr.sin_zero), 8);

    if (connect (sockfd, (struct sockaddr *)&their_addr,
                 sizeof (struct sockaddr)) == -1 )
    {
        textfield_add (strerror(errno), MESSAGE_ERR);
        return;
    }

    textfield_add ( "*** Connection established.\n", MESSAGE_NORMAL);

    input_monitor = gdk_input_add (sockfd, GDK_INPUT_READ,
    				   read_from_connection,
    				   NULL );
    connected = TRUE;
    echo = TRUE;
}

void read_from_connection (gpointer data, gint source, GdkInputCondition condition)
{
    char buf[2048];
    int  numbytes;
    
    if ( (numbytes = recv (sockfd, buf, 2048, 0) ) == - 1 )
    {
        textfield_add ( strerror( errno), MESSAGE_ERR);
        disconnect ( );
        return;
    }

    buf[numbytes] = '\0';

    /*
     * Sometimes we get here even though there isn't any data to read
     * from the socket..
     *
     * found by Michael Stevens
     */
    if ( numbytes == 0 )
    {
	textfield_add ( "*** 0 byte packet received\n", MESSAGE_ERR);
        disconnect ();
        return;
    }


		/* this sucker strips the stat line outta the
		   main window and puts it in the stat box */

	if(buf[numbytes-2]=='>'){
		int x=numbytes;
		while(buf[x]!='\n')x--;
		statbar_add((gchar *)&buf[x]);
		buf[x-1]=0;	/* -1 to remove another \n */
		}		

    textfield_add ( buf, MESSAGE_ANSI);
    return;
}

void send_to_connection ( GtkWidget *widget, gpointer data)
{
    gchar *entry_text;

    entry_text = gtk_entry_get_text (GTK_ENTRY (mud->ent));
    gtk_entry_select_region (GTK_ENTRY (mud->ent), 0,
                             GTK_ENTRY (mud->ent)->text_length);

	if(entry_text[0]=='/'||entry_text[0]=='#'){
		do_alias((char *)&entry_text[1]); /* strips the / or # */
		gtk_entry_set_text(GTK_ENTRY(mud->ent),"");
		return;
		}

    /* if it wasn't an alias, do this */

    send (sockfd, entry_text, strlen (entry_text), 0);
    send (sockfd, "\n", 1, 0);

    if ( echo )
    {
        textfield_add ( entry_text, MESSAGE_ANSI);
        textfield_add ( "\n", MESSAGE_NONE);
    }
	gtk_entry_set_text(GTK_ENTRY(mud->ent),""); /* clear the entry line */
}
